// /***************************************************************************
//                           ezmatch  -  description
//                              -------------------
//     begin                : Feb. 18, 2008
//     copyright            : (C) 2008 by Allen
//     email                : bon_ami_@hotmail.com
//  ***************************************************************************/
//
// /***************************************************************************
//  *                                                                         *
//  *   Explicit Distribution Limitation                                      *
//  *   This rule overrides others below.                                     *
//  *   This program may not be modified or used by, or, if possible,         *
//  *   redistributed to people described as below,                           *
//  *   1.Japanese who hold hostility against Chinese.                        *
//  *   2.or, those who discriminate against people based solely on race,     *
//  *     gender or sexual orientation.                                       *
//  *                                                                         *
//  ***************************************************************************/
// /***************************************************************************
//  *                                                                         *
//  *   This program is free software; you can redistribute it and/or modify  *
//  *   it under the terms of the GNU General Public License as published by  *
//  *   the Free Software Foundation; either version 2 of the License, or     *
//  *   (at your option) any later version.                                   *
//  *                                                                         *
//  ***************************************************************************/
// /*
//  *	code of EZ Match Project example functionalities
//  */
//

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <utility>

void _____________list();
/*
 * List definitions.
 */
#define LIST_HEAD(name, type)						\
struct name {								\
	struct type *lh_first;	/* first element */			\
	struct type *lh_last;	/* newly added. last element */			\
}

#define LIST_HEAD_INITIALIZER(head)					\
	{ NULL, NULL }	/* not used! */

#define LIST_ENTRY(type)						\
struct {								\
	struct type *le_next;	/* next element */			\
	struct type **le_prev;	/* address of previous next element */	\
}

/*
 * List access methods
 */
#define	LIST_FIRST(head)		((head)->lh_first)
#define	LIST_LAST(head)		((head)->lh_last)
#define	LIST_END(head)			NULL
#define	LIST_EMPTY(head)		(LIST_FIRST(head) == LIST_END(head))	/* not used */
#define	LIST_NEXT(elm, field)		((elm)->field.le_next)

#define LIST_FOREACH(var, head, field)					\
	for(;					\
	    (var)!= LIST_END(head);					\
	    (var) = LIST_NEXT(var, field))

/*
 * List functions.
 */
#define	LIST_INIT(head) do {						\
	LIST_FIRST(head) = LIST_LAST(head) = LIST_END(head);				\
} while (0)	/* not even used! */

#define LIST_INSERT_AFTER(listelm, elm, field) do {			\
	if (((elm)->field.le_next = (listelm)->field.le_next) != NULL)	\
		(listelm)->field.le_next->field.le_prev =		\
		    &(elm)->field.le_next;				\
	(listelm)->field.le_next = (elm);				\
	(elm)->field.le_prev = &(listelm)->field.le_next;		\
} while (0)	/* not used */

#define	LIST_INSERT_BEFORE(listelm, elm, field) do {			\
	(elm)->field.le_prev = (listelm)->field.le_prev;		\
	(elm)->field.le_next = (listelm);				\
	*(listelm)->field.le_prev = (elm);				\
	(listelm)->field.le_prev = &(elm)->field.le_next;		\
} while (0)	/* not used */

#define LIST_INSERT_HEAD(head, elm, field) do {				\
	if (((elm)->field.le_next = (head)->lh_first) != NULL)		\
		(head)->lh_first->field.le_prev = &(elm)->field.le_next;\
	else (head)->lh_last = (elm);				\
	(head)->lh_first = (elm);					\
	(elm)->field.le_prev = &(head)->lh_first;			\
} while (0)	/* obsolete */

#define LIST_INSERT_TAIL(head, elm, field) do {				\
	(elm)->field.le_next = LIST_END(head);		\
	if (LIST_LAST(head) != NULL)		\
	{ (elm)->field.le_prev = &(head)->lh_last->field.le_next;		\
		(head)->lh_last->field.le_next = (elm); }\
	else {	(head)->lh_first = (elm); (elm)->field.le_prev = &(head)->lh_first; }\
	(head)->lh_last = (elm);					\
} while (0)

#define LIST_REMOVE(elm, field) do {					\
	if ((elm)->field.le_next != NULL)				\
		(elm)->field.le_next->field.le_prev =			\
		    (elm)->field.le_prev;				\
	*(elm)->field.le_prev = (elm)->field.le_next;			\
} while (0)	/* lh_last is lost from now on. do not insert from this point. */

#define LIST_REPLACE(elm, elm2, field) do {				\
	if (((elm2)->field.le_next = (elm)->field.le_next) != NULL)	\
		(elm2)->field.le_next->field.le_prev =			\
		    &(elm2)->field.le_next;				\
	(elm2)->field.le_prev = (elm)->field.le_prev;			\
	*(elm2)->field.le_prev = (elm2);				\
} while (0)	/* not used */

LIST_HEAD(mem_list_head, mem_data);
	
struct mem_data
{
	LIST_ENTRY(mem_data) mem_list;
	std::string addr;
	size_t size;
	char *filename;
	int line;
};


void _____________mem_analasys();
struct mem_list_head head;
int mallocnum;

/* add to the list. */
void mem_check_malloc (std::string &value, size_t size, char *line, int linenum)
{
	struct mem_data *pdata;

	pdata = new mem_data; //(struct mem_data *)malloc(sizeof(struct mem_data));
	pdata->addr = value;
	pdata->size = size;
	pdata->filename = (char *)malloc(strlen(line) + 1);
	sprintf(pdata->filename, "%s", line);
	pdata->line = linenum;
	LIST_INSERT_TAIL(&head, pdata, mem_list);
	mallocnum++;
}

/* remove from the list. */
void mem_check_free (std::string &addr, char *file, int linenum)
{
	struct mem_data *pdata = LIST_FIRST(&head);
	unsigned long index;

	index = 0;
	LIST_FOREACH(pdata, &head, mem_list) {
		if (pdata->addr == addr){
			LIST_REMOVE(pdata, mem_list);
			free(pdata->filename);
			delete pdata;
			mallocnum--;
			return;
		}
	}
}

/* for each of the not freed list. */
int mem_check_result(int &max_len, std::string &res)
{
	char num_buf[10];
	static struct mem_data *pdata = LIST_FIRST(&head);
	static unsigned int count = 0;

	if (max_len < 0)
	{
		pdata = LIST_FIRST(&head);
		count = 0;
		max_len = -max_len;
	}
	LIST_FOREACH(pdata, &head, mem_list) {
		sprintf(num_buf, "%d", pdata->line);
		res.append(num_buf);
		res.append(" ");
		res.append(pdata->filename);
		res.append("\n");
		count++;
		if (res.length() > max_len)
		{
			max_len = mallocnum;
			pdata = LIST_NEXT(pdata, mem_list);
			return count;
		}
	}
	max_len = 0;
	return count;
}

void mem_check_clear(void)
{
	struct mem_data *pdata, *tmp;

	for (pdata = LIST_FIRST(&head); pdata != LIST_END(&head); )
	{
		tmp = pdata;
		pdata = LIST_NEXT(pdata, mem_list);
		LIST_REMOVE(tmp, mem_list);
		free(tmp->filename);
		delete tmp;
	}
	/* lh_last correction */
	LIST_LAST(&head) = LIST_END(&head);
}


void _____________file_parse();

/*   Set   line   length   in   configuration   files   */     
#define   CFG_LINE 1024   
static int readline(char *line, FILE *stream)   
{
	int flag = 1;
	char buf[CFG_LINE];
	unsigned int i, k = 0;

	if (fgets(buf, CFG_LINE, stream) != NULL) {
		/* Delete the last '\r' or '\n' or ' ' or '\t' character */
		for (i = strlen(buf) - 1; i >= 0; i--) {
			if ( buf[i] == '\r' || buf[i] == '\n' || buf[i] == ' ' || buf[i] == '\t' )
				buf[i] = '\0';
			else
				break;   /* dap loop */
	}

	/* Delete the front '\r' or '\n' or ' ' or '\t' character */
	for (i = 0; i <= strlen(buf); i++) {
		if (flag && (buf[i] == '\r' || buf[i] == '\n' || buf[i] == ' ' || buf[i] == '\t')) {
			continue;
		}
		else{
			flag = 0;
			line[k++] = buf[i];
		}
	}

	return 0;
	}
	return -1;
}

#define INITMALLOC 1
#define FREEMALLOC 2
typedef struct _mem_info
{
	std::string addr;
	int type;
}mem_info;

mem_info *mem_info_new(void)
{
	mem_info *meminfo;
	meminfo = new mem_info; //(mem_info *)malloc(sizeof(mem_info));
	//meminfo->type = 0;
	return meminfo;
}

void mem_info_destroy(mem_info *meminfo)
{
	if (NULL != meminfo)
		delete meminfo;
}

/* 
  * parse the line.
  * returns: the type of memory operation, -1 if failed.
  */
int mem_line_parse(char *line, mem_info *meminfo,
	std::pair<std::string, std::string> strings,
	std::pair<std::string, std::string> keystrings)
{
	char *ptr = NULL, *tmp;
	if (NULL != strstr(line, strings.first.c_str()))
		meminfo->type = INITMALLOC;
	else if (NULL != strstr(line, strings.second.c_str()))
		meminfo->type = FREEMALLOC;
	else
		return -1;

	/* get the addr. */
	if (NULL == (ptr = strstr(line, keystrings.first.c_str())))
		return -1;
	tmp = strdup(ptr + 6);
	if (NULL != (ptr = strstr(tmp, keystrings.second.c_str())))
		*ptr = '\0';
	meminfo->addr = tmp; //strtol(tmp, NULL, 16);
	free(tmp);
	return meminfo->type;
}

void _____________main();

int memchk_main(std::string filename,
	std::pair<std::string, std::string> strings,
	std::pair<std::string, std::string> keystrings)
{
	char line[CFG_LINE];
	FILE *fd;
	int line_num, error;
	mem_info *meminfo;
	std::string res;
	int direct_front, direct_rear;

	if (NULL == (fd = fopen(filename.c_str(), "r"))) {
		return -1;
	}
	
	/* analysis every line in time. */
	for (line_num = 1; 0 == readline(line, fd); line_num++)
	{
		meminfo = mem_info_new();
		error = mem_line_parse(line, meminfo, strings, keystrings);
		if (INITMALLOC == error)
			mem_check_malloc(meminfo->addr, 10, line, line_num);
		mem_info_destroy(meminfo);
	}
	rewind(fd);
	for (line_num = 1; 0 == readline(line, fd); line_num++)
	{
		meminfo = mem_info_new();
		error = mem_line_parse(line, meminfo, strings, keystrings);
		if (FREEMALLOC == error)
			mem_check_free(meminfo->addr, line, line_num);
		mem_info_destroy(meminfo);
	}
	
	fclose(fd);
	return line_num;
}
