// /***************************************************************************
//                           ezmatch  -  description
//                              -------------------
//     begin                : Feb. 18, 2008
//     copyright            : (C) 2008 by Allen
//     email                : bon_ami_@hotmail.com
//  ***************************************************************************/
//
// /***************************************************************************
//  *                                                                         *
//  *   Explicit Distribution Limitation                                      *
//  *   This rule overrides others below.                                     *
//  *   This program may not be modified or used by, or, if possible,         *
//  *   redistributed to people described as below,                           *
//  *   1.Japanese who hold hostility against Chinese.                        *
//  *   2.or, those who discriminate against people based solely on race,     *
//  *     gender or sexual orientation.                                       *
//  *                                                                         *
//  ***************************************************************************/
// /***************************************************************************
//  *                                                                         *
//  *   This program is free software; you can redistribute it and/or modify  *
//  *   it under the terms of the GNU General Public License as published by  *
//  *   the Free Software Foundation; either version 2 of the License, or     *
//  *   (at your option) any later version.                                   *
//  *                                                                         *
//  ***************************************************************************/
// /*
//  *	header of EZ Match Project main functionalities
//  */
//

#ifndef _ezmatch_ezmatch_h
#define _ezmatch_ezmatch_h

#include <CtrlLib/CtrlLib.h>

using namespace Upp;

#define LAYOUTFILE <ezmatch/ezmatch.lay>
#include <CtrlCore/lay.h>

#define IMAGEFILE <ezmatch/ezmatch.iml>
#include <Draw/iml_header.h>

class ConfigWin : public TopWindow {
public:
	typedef ConfigWin CLASSNAME;
	ConfigWin();
	~ConfigWin() {};
	void Set(std::string, std::string, std::string, std::string);
	void Get(std::string&, std::string&, std::string&, std::string&);

private:
	virtual bool HotKey(dword key);
	void Config_set();
	void Config_notset();

	LabelBox lbl_alloc;
	LabelBox lbl_free;
	LabelBox lbl_head;
	LabelBox lbl_tail;
	EditString edit_alloc;
	EditString edit_free;
	EditString edit_head;
	EditString edit_tail;
	Button but_ok;
	Button but_ng;
};

class ezmatch : public WithezmatchLayout<TopWindow> {
public:
	typedef ezmatch CLASSNAME;
	ezmatch();

private:
	virtual void Layout();
	void About();
	void Help();
	void CopyAll();
	void ClearAll();
	void SaveAll();
	void AppendAll();
	void Menu(Bar& bar);
	void FileMenu(Bar& bar);
	void EditMenu(Bar& bar);
	void HelpMenu(Bar& bar);
	void File_butt();
	void Direct_swit();
	void Do_buttPush();
	void WClose();
	virtual bool HotKey(dword key);
	void Config(void);

	MenuBar menu;
	Bar::Item *edit_menu;
	FileSel brs;
	String text_alloc;
	String text_free;
	ConfigWin config;
	std::string config_alloc;
	std::string config_free;
	std::string config_head;
	std::string config_tail;
} ;

#endif

